commit a56b7f4f286ff46c4f2cf8465a87d55ce6d55167
Author: freddy77 <freddy77>
Date:   Wed Sep 17 12:16:06 2008 +0000

    autogenerate some functions based on types.txt

diff --git a/ChangeLog b/ChangeLog
index 1cfef99..97c2027 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Wed Sep 17 14:14:15 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/.cvsignore src/tds/Makefile.am src/tds/convert.c:
+	* src/tds/data.c src/tds/read.c src/tds/types.pl(added):
+	- autogenerate some functions based on types.txt
+
 Sun Sep 14 09:44:55 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/odbc/odbc.c src/tds/mem.c src/tds/token.c:
 	- renamed TDSSOCKET->no_data_conv to TDSSOCKET->use_iconv
@@ -653,4 +658,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2609 2008/09/14 07:45:24 freddy77 Exp $
+$Id: ChangeLog,v 1.2610 2008/09/17 12:16:06 freddy77 Exp $
diff --git a/src/tds/.cvsignore b/src/tds/.cvsignore
index f9b4f83..1460e60 100644
--- a/src/tds/.cvsignore
+++ b/src/tds/.cvsignore
@@ -8,4 +8,5 @@ num_limits.h
 sybase_character_sets.h
 tds_willconvert.h
 encodings.h
+types.h
 
diff --git a/src/tds/Makefile.am b/src/tds/Makefile.am
index be636b9..eba44e8 100644
--- a/src/tds/Makefile.am
+++ b/src/tds/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.64 2008/07/30 08:02:55 freddy77 Exp $
+# $Id: Makefile.am,v 1.65 2008/09/17 12:16:07 freddy77 Exp $
 
 SUBDIRS			=	unittests
 AM_CPPFLAGS		=	-I$(top_srcdir)/include
@@ -13,8 +13,8 @@ libtds_la_SOURCES=	mem.c token.c util.c login.c read.c \
 libtds_la_LDFLAGS=
 libtds_la_LIBADD=
 
-noinst_HEADERS		= tds_willconvert.h encodings.h num_limits.h
-EXTRA_DIST		= tds_willconvert.h encodings.h num_limits.h
+noinst_HEADERS		= tds_willconvert.h encodings.h num_limits.h types.h
+EXTRA_DIST		= tds_willconvert.h encodings.h num_limits.h types.h
 
 if HAVE_DOXYGEN
 doxyfile: $(srcdir)/tds.dox
@@ -52,4 +52,8 @@ encodings.h: encodings.pl alternative_character_sets.h Makefile
 num_limits.h: num_limits.pl Makefile
 	perl $(srcdir)/num_limits.pl > $@.tmp
 	mv $@.tmp $@
+
+types.h: types.pl Makefile ../../misc/types.txt
+	perl $(srcdir)/types.pl < $(srcdir)/../../misc/types.txt > $@.tmp
+	mv $@.tmp $@
 endif
diff --git a/src/tds/convert.c b/src/tds/convert.c
index 606f3fc..89b4e32 100644
--- a/src/tds/convert.c
+++ b/src/tds/convert.c
@@ -64,7 +64,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert.c,v 1.183 2008/06/12 01:00:48 jklowden Exp $");
+TDS_RCSID(var, "$Id: convert.c,v 1.184 2008/09/17 12:16:08 freddy77 Exp $");
 
 typedef unsigned short utf16_t;
 
@@ -142,64 +142,6 @@ static const char *tds_prtype(int token);
 const char tds_hex_digits[16] = "0123456789abcdef";
 
 /**
- * Return type suitable for conversions (convert all nullable types to 
- * fixed type)
- * @param srctype type to convert
- * @param colsize size of type
- * @result type for conversion
- */
-int
-tds_get_conversion_type(int srctype, int colsize)
-{
-	switch (srctype) {
-	case SYBINTN:
-		switch (colsize) {
-		case 8:
-			return SYBINT8;
-		case 4:
-			return SYBINT4;
-		case 2:
-			return SYBINT2;
-		case 1:
-			return SYBINT1;
-		}
-		break;
-	case SYBFLTN:
-		switch (colsize) {
-		case 8:
-			return SYBFLT8;
-		case 4:
-			return SYBREAL;
-		}
-		break;
-	case SYBDATETIMN:
-		switch (colsize) {
-		case 8:
-			return SYBDATETIME;
-		case 4:
-			return SYBDATETIME4;
-		}
-		break;
-	case SYBMONEYN:
-		switch (colsize) {
-		case 8:
-			return SYBMONEY;
-		case 4:
-			return SYBMONEY4;
-		}
-		break;
-		/*
-		 * altough tds_convert handle SYBBITN other routine use this
-		 * function to retrieve not variant type
-		 */
-	case SYBBITN:
-		return SYBBIT;
-		break;
-	}
-	return srctype;
-}
-
-/**
  * Copy a terminated string to result and return len or TDS_CONVERT_NOMEM
  */
 static TDS_INT
diff --git a/src/tds/data.c b/src/tds/data.c
index 96ab068..3c81ff5 100644
--- a/src/tds/data.c
+++ b/src/tds/data.c
@@ -35,7 +35,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: data.c,v 1.18 2007/06/21 07:21:21 freddy77 Exp $");
+TDS_RCSID(var, "$Id: data.c,v 1.19 2008/09/17 12:16:08 freddy77 Exp $");
 
 #if !ENABLE_EXTRA_CHECKS
 static int tds_get_cardinal_type(int datatype);
@@ -163,61 +163,4 @@ tds_get_cardinal_type(int datatype)
 	return datatype;
 }
 
-/**
- * tds_get_varint_size() returns the size of a variable length integer
- * returned in a TDS 7.0 result string
- */
-#if !ENABLE_EXTRA_CHECKS
-static
-#endif
-int
-tds_get_varint_size(TDSSOCKET * tds, int datatype)
-{
-	switch (datatype) {
-	case SYBTEXT:
-	case SYBNTEXT:
-	case SYBIMAGE:
-		return 4;
-	case SYBVOID:
-	case SYBINT1:
-	case SYBBIT:
-	case SYBINT2:
-	case SYBINT4:
-	case SYBINT8:
-	case SYBDATETIME4:
-	case SYBREAL:
-	case SYBMONEY:
-	case SYBDATETIME:
-	case SYBFLT8:
-	case SYBMONEY4:
-	case SYBSINT1:
-	case SYBUINT2:
-	case SYBUINT4:
-	case SYBUINT8:
-		return 0;
-	}
-
-	if (IS_TDS7_PLUS(tds)) {
-		switch (datatype) {
-		/* TODO support this strange type */
-		case SYBVARIANT:
-			return 4;
-		case XSYBCHAR:
-		case XSYBNCHAR:
-		case XSYBNVARCHAR:
-		case XSYBVARCHAR:
-		case XSYBBINARY:
-		case XSYBVARBINARY:
-			return 2;
-		}
-	} else if (IS_TDS50(tds)) {
-		switch (datatype) {
-		case SYBLONGBINARY:
-		case SYBLONGCHAR:
-			return 5;
-		case SYB5INT8:
-			return 0;
-		}
-	}
-	return 1;
-}
+#include "types.h"
diff --git a/src/tds/read.c b/src/tds/read.c
index 4abfe7b..76a8b48 100644
--- a/src/tds/read.c
+++ b/src/tds/read.c
@@ -47,7 +47,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: read.c,v 1.106 2007/12/27 13:45:23 freddy77 Exp $");
+TDS_RCSID(var, "$Id: read.c,v 1.107 2008/09/17 12:16:08 freddy77 Exp $");
 
 static int read_and_convert(TDSSOCKET * tds, const TDSICONV * char_conv,
 			    size_t * wire_size, char **outbuf, size_t * outbytesleft);
@@ -315,63 +315,6 @@ tds_get_n(TDSSOCKET * tds, void *dest, int need)
 	return dest;
 }
 
-/**
- * Return the number of bytes needed by specified type.
- */
-int
-tds_get_size_by_type(int servertype)
-{
-	switch (servertype) {
-	case SYBINT1:
-		return 1;
-		break;
-	case SYBINT2:
-		return 2;
-		break;
-	case SYBINT4:
-		return 4;
-		break;
-	case SYB5INT8:
-	case SYBINT8:
-		return 8;
-		break;
-	case SYBREAL:
-		return 4;
-		break;
-	case SYBFLT8:
-		return 8;
-		break;
-	case SYBDATETIME:
-		return 8;
-		break;
-	case SYBDATETIME4:
-		return 4;
-		break;
-	case SYBBIT:
-		return 1;
-		break;
-	case SYBBITN:
-		return 1;
-		break;
-	case SYBMONEY:
-		return 8;
-		break;
-	case SYBMONEY4:
-		return 4;
-		break;
-	case SYBUNIQUE:
-		return 16;
-		break;
-	/* this strange type is used just for null placeholder in rpc */
-	case SYBVOID:
-		return 0;
-		break;
-	default:
-		return -1;
-		break;
-	}
-}
-
 /*
  * For UTF-8 and similar, tds_iconv() may encounter a partial sequence when the chunk boundary
  * is not aligned with the character boundary.  In that event, it will return an error, and
diff --git a/src/tds/types.pl b/src/tds/types.pl
new file mode 100755
index 0000000..a4cd760
--- /dev/null
+++ b/src/tds/types.pl
@@ -0,0 +1,151 @@
+#!/usr/bin/perl
+
+use strict;
+
+sub readLine()
+{
+	my $line;
+	while ($line = <>) {
+		chomp $line;
+		# remove comments
+		$line =~ s/#.*//;
+		# removed unused spaces at the end
+		$line =~ s/\s+$//;
+		# if not empty return it
+		return $line if $line;
+	}
+	return $line;
+}
+
+# read header
+my $hdr = lc(readLine());
+$hdr =~ s/ /_/g;
+my @fields = split("\t", $hdr);
+
+# read all files
+my %types;
+my $line;
+while ($line = readLine()) {
+	my %type;
+	@type{@fields} = split("\t", $line);
+	$types{$type{'name'}} = \%type;
+}
+
+my $id = '$Id: types.pl,v 1.1 2008/09/17 12:16:09 freddy77 Exp $';
+$id =~ s/\$Id/CVS Id/;
+$id =~ s/\$\s*$//;
+print qq|/*
+ * This file produced from $0
+ * $id
+ */
+
+|;
+
+sub unique($)
+{
+	return keys %{{ map { $_ => 1 } @_ }};
+}
+
+sub switchValues()
+{
+	my ($indent, $column, @list) = @_;
+	foreach my $value (sort { $a <=> $b } &unique(map { $_->{$column} } @list)) {
+		print $indent.qq|case $_:\n| for (sort map { $_->{'name'} } grep { $_->{$column} eq $value } @list);
+		print $indent.qq|	return $value;\n|;
+	}
+}
+
+# generate tds_get_size_by_type function
+print q|/**
+ * Return the number of bytes needed by specified type.
+ */
+int
+tds_get_size_by_type(int servertype)
+{
+	switch (servertype) {
+|;
+my @list = grep { $_->{'size'} != -1 } values %types;
+&switchValues("\t", 'size', @list);
+print q|	default:
+		return -1;
+	}
+}
+
+|;
+
+# generate tds_get_varint_size
+print q|/**
+ * tds_get_varint_size() returns the size of a variable length integer
+ * returned in a TDS 7.0 result string
+ */
+#if !ENABLE_EXTRA_CHECKS
+static
+#endif
+int
+tds_get_varint_size(TDSSOCKET * tds, int datatype)
+{
+	switch (datatype) {
+|;
+@list = grep { $_->{'varint'} != 1 && $_->{'varint'} ne '??' && uc($_->{'vendor'}) ne 'MS' && uc($_->{'vendor'}) ne 'SYB' } values %types;
+&switchValues("\t", 'varint', @list);
+print q|	}
+
+	if (IS_TDS7_PLUS(tds)) {
+		switch (datatype) {
+|;
+@list = grep { $_->{'varint'} != 1 && $_->{'varint'} ne '??' && uc($_->{'vendor'}) eq 'MS' } values %types;
+&switchValues("\t\t", 'varint', @list);
+print q|		}
+	} else if (IS_TDS50(tds)) {
+		switch (datatype) {
+|;
+@list = grep { $_->{'varint'} != 1 && $_->{'varint'} ne '??' && uc($_->{'vendor'}) eq 'SYB' } values %types;
+&switchValues("\t\t", 'varint', @list);
+print q|		}
+	}
+	return 1;
+}
+
+|;
+
+#generate
+
+print q|/**
+ * Return type suitable for conversions (convert all nullable types to fixed type)
+ * @param srctype type to convert
+ * @param colsize size of type
+ * @result type for conversion
+ */
+int
+tds_get_conversion_type(int srctype, int colsize)
+{
+	switch (srctype) {
+|;
+# extract all types that have nullable representation
+# exclude SYB5INT8 cause it collide with SYBINT8
+@list = grep { $_->{'nullable_type'} ne "0" && $_->{name} ne 'SYB5INT8' } values %types;
+foreach my $type (@list)
+{
+	die("$type->{name} should be not nullable") if $type->{nullable};
+	die("$type->{name} has invalid nullable type") if !exists($types{$type->{nullable_type}});
+}
+foreach my $type (sort &unique(map { $_->{nullable_type} } @list)) {
+	my @list2 = grep { $_->{nullable_type} eq $type } @list;
+	print qq|	case $type:\n|;
+	if ($#list2 == 0) {
+		print qq|		return $list2[0]->{name};\n|;
+	} else {
+		print qq|		switch (colsize) {\n|;
+		foreach my $item (sort { $b->{size} <=> $a->{size} } @list2) {
+			print qq|		case $item->{size}:
+			return $item->{name};\n|;
+		}
+		print qq|		}
+		break;\n|;
+	}
+}
+print q|	}
+	return srctype;
+}
+
+|;

